;;;
;;; gnomen.scm --- simple group nomenclature
;;;

(define name-group
  (make-threaded-solver #f 1))

(defsolver name-group
  (lambda (g)
    (if (cyclic? g)
        (list 'cyclic (group-order g))
        unknown)))

(define find-generators
  (make-threaded-solver #f 1))

(defsolver find-generators
  (lambda (g)
    (let lp ((generators '())
             (to-try (group-elements g)))
      (let ((g2 (make-generator-group generators (group-operation g))))
        (if (= (group-order g) (group-order g2))
            generators
            (if (null? to-try)
                #f
                (let ((try1 (lp generators (cdr to-try))))
                  (if try1
                      try1
                      (lp (cons (car to-try) generators) (cdr to-try))))))))))

;;; Examples
#|
(find-generators (make-symmetric-group 4))
;Value 18: ((3 2 0 1) (3 1 2 0))

(find-generators (make-symmetric-group 5))
;Value 19: ((4 3 2 0 1) (4 3 1 2 0))

(find-generators (make-cyclic-group 6))
;Value 20: (5)
|#